local lgr = love.graphics

local shrinkyRect = {}
function shrinkyRect:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function shrinkyRect:setup(v)
	self.x = v.x or 100
	self.y = v.y or 100
	self.w = v.w or 100
	self.h = v.h or 100

	self.ex = v.ex or 150
	self.ey = v.ey or 150
	self.ew = v.ew or 0
	self.eh = v.eh or 0

	self.life = 0.2

	self.removeThis = false

	self.endFunc = v.endFunc or function() print("Empty") end

	self.flux = flux.group()

	self.flux:to(self, self.life, { x = self.ex, y = self.ey, w = self.ew, h = self.eh }):ease("linear"):oncomplete(function()
		self:endFunc()
		self.removeThis = true
	end)
end

function shrinkyRect:update(dt)
	self.flux:update(dt)
end

function shrinkyRect:draw()
	lgr.setColor(0,0,0,0.8)
	lgr.rectangle("line", self.x, self.y, self.w, self.h)
end

return shrinkyRect
