local lgr = love.graphics

local _obj = {}
function _obj:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function _obj:setup(v)
	self.x = v.x or 0
	self.y = v.y or 0
	self.w = 6
	self.h = 6

	self.symbol = v.symbol or "close"

	self.callback = v.callback or function() print("No Callback") end
end

function _obj:update(dt)

end

function _obj:draw()
	lgr.setColor(0,0,0,0.5)
	lgr.rectangle("line", self.x, self.y, self.w, self.h)
	if self.symbol == "minimize" then
		lgr.setColor(0,0,0,0.25)
		lgr.line(self.x, self.y + 2, self.x + self.w - 1, self.y + 2)
		lgr.line(self.x, self.y + 1, self.x + self.w - 1, self.y + 1)
	elseif self.symbol == "close" then
	lgr.setColor(0,0,0,0.25)
		lgr.rectangle("fill", self.x, self.y, self.w - 1, self.h - 1)
	end
end

function _obj:mousepressed(x, y, button)
	local x2, y2 = x - self.x, y - self.y
	if overlap(x2, y2, 1, 1, -1, -1, 10, 10) then
		print("Clicked this button!", self.symbol)
		print()
		self.isBeingClicked = true
		return true
	end
	return false
end

function _obj:mousereleased(x, y, button)
	local x2, y2 = x - self.x, y - self.y
	if self.isBeingClicked then
		self.callback()
	end
end


return _obj
