local lgr = love.graphics
local lfs = love.filesystem

local _app = {
	updateInBackground = true,
}

local fileListObj = require(CUR_GAME..'.library.fileListObj')

function _app:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function _app:setup(v)
	self.loaded = true

	self.w = v.w or 0
	self.h = v.h or 0

	self.appID = v.appID or "orphan"

	self.bgColor = {1,1,1}


	self.parent = v.parent

	local a = v.args or {}

	self.directory = CUR_GAME.."/drive/" .. (a.directory or a.dir or "")
	print("Folder View:", self.directory)

	self.contents = {}
	local c = lfs.getDirectoryItems(self.directory)
	for i = 1, #c do
		local info = lfs.getInfo(self.directory.."/"..c[i])
		if c[i] ~= ".DS_Store" then
			k = info.type
			self.contents[#self.contents+1] = {name = c[i], kind = k}
		end
	end

	self.container = fileListObj:create { x = 0, y = 0, w = self.w, h = self.h, dir = self.directory, parent = self }

	self.defaultTitle = self.directory:gsub(CUR_GAME.."/drive", "")
end

function _app:update(dt)
	self.container:update(dt)
end

function _app:draw()
	-- lgr.setFont(font.dialog)
	-- lgr.setColor(0,0,0)
	-- for i, c in pairs(self.contents) do
	-- 	if c.kind == "directory" then
	-- 		lgr.print(">", 2, i * 12)
	-- 	end
	-- 	lgr.print(c.name, 16, i * 12)
	-- end

	self.container:draw()
end

function _app:mousepressed(x, y, button)
	self.container:mousepressed(x, y, button)
end

function _app:mousereleased(x, y, button)
	self.container:mousereleased(x, y, button)
end

function _app:doubleclick(x, y, button)
	self.container:doubleclick(x, y, button)
end

function _app:resize(w, h)
	if not self.parent.isResizing then
		self.w = w
		self.h = h
	end
	self.container:resize(w, h)
end

return _app
