local lgr = love.graphics

local _app = {
	updateInBackground = true,
}

function _app:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function _app:setup(v)
	self.loaded = true

	self.w = (v.w or 0)
	self.h = (v.h or 0)

	self.parent = v.parent

	self.appID = v.appID or "orphan"

	self.bgColor = {0.2,0.2,0.2}

	self.image = lgr.newImage((v.args.file or "/Files/Images/through_the_grass.jpg"))
	self.image:setFilter("linear", "nearest")
	self.imgWidth = self.image:getWidth()
	self.imgHeight = self.image:getHeight()

	self:updateScale()

	print(v.args.file, self.scale * self.imgWidth)
	self.parent.w = math.floor(self.scale * self.imgWidth) + 2
	self.parent.adjust = true
	-- self.parent:resize()
	-- print(self.parent.w)

	self.defaultTitle = v.args.file:gsub(CUR_GAME.."/drive", "C:")--"Image Viewer"
end

function _app:update(dt)
	self:updateScale()
end

function _app:draw()
	local x, y
	x = (self.w - (self.scale * self.imgWidth)) / 2
	y = (self.h - (self.scale * self.imgHeight)) / 2

	lgr.setColor(1,1,1)
	lgr.draw(self.image, x, y, 0, self.scale, self.scale)

	lgr.setFont(font.tinybordered)

	lgr.setColor(1,1,1)
	lgr.printf(math_round(((self.scale or 0) * 100), 1) .. "%", self.w - 45, self.h - 8, 30, "right")
end

function _app:unload()
	self.loaded = false
end

function _app:resize(w, h)
	self.w = w
	self.h = h

	self.circleX = math.random() * self.w
	self.circleY = math.random() * self.h

	self.defaultTitle = "Image Viewer " .. math_round(self.scale, 1)
end

function _app:updateScale()
	self.scale = math.min((self.h / self.imgHeight), (self.w / self.imgWidth))
end

return _app
