local lgr = love.graphics
local tmr = love.timer

local _app = {
	updateInBackground = true,
	noResize = true,
	noMinimize = true
}

function _app:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function _app:setup(v)
	self.loaded = true

	self.w = v.w or 0
	self.h = v.h or 0

	self.parent = v.parent

	self.appID = v.appID or "orphan"

	self.circleX = self.w / 2
	self.circleY = self.h / 2
	self.color = {math.random(), math.random(), math.random()}
	self.bgColor = {0.3,0.3,0.4}

	self.defaultTitle = "noResize"
end

function _app:update(dt)
end

function _app:draw()
	lgr.push()
	lgr.translate(math.floor(self.circleX), math.floor(self.circleY))
	lgr.rotate(tmr.getTime())
	lgr.setColor(1,1,1)
	lgr.circle("fill", 0, 0, 22, 3)
	lgr.setColor(self.color)
	lgr.circle("fill", 0, 0, 20, 3)
	lgr.pop()
end

function _app:unload()
	self.loaded = false
end

function _app:resize(w, h)
	self.w = w
	self.h = h

	self.circleX = self.w / 2
	self.circleY = self.h / 2
end

return _app
