local lgr = love.graphics

local _app = {
	updateInBackground = true
}

function _app:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function _app:setup(v)
	self.loaded = true

	self.w = v.w or 0
	self.h = v.h or 0

	self.parent = v.parent

	self.appID = v.appID or "orphan"

	self.rectX = math.random() * self.w
	self.rectY = math.random() * self.h
	self.rectDirX = 1
	self.rectDirY = 1
	self.color = {math.random(), math.random(), math.random()}
	self.bgColor = {0.5,0.5,0.6}

	self.defaultTitle = "Bouncy Rect"
end

function _app:update(dt)
	self.rectX = self.rectX + dt * self.rectDirX * 50
	self.rectY = self.rectY + dt * self.rectDirY * 50
	if self.rectX > self.w or self.rectX <= 0 then
		self.rectDirX = -self.rectDirX
	end
	if self.rectY > self.h or self.rectY <= 0 then
		self.rectDirY = -self.rectDirY
	end
end

function _app:draw()
	lgr.setColor(1,1,1)
	lgr.rectangle("fill", math.floor(self.rectX - 11), math.floor(self.rectY - 11), 22, 22, 4)
	lgr.setColor(self.color)
	lgr.rectangle("fill", math.floor(self.rectX - 10), math.floor(self.rectY - 10), 20, 20, 3)
end

function _app:unload()
	self.loaded = false
end

function _app:resize(w, h)
	if not self.parent.isResizing then
		self.w = w
		self.h = h

		self.rectX = math.random() * self.w
		self.rectY = math.random() * self.h
	end
end

return _app
