local lgr = love.graphics

local _app = {
	updateInBackground = true
}

function _app:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v)
	return _i
end
function _app:setup(v)
	self.loaded = true

	self.w = v.w or 0
	self.h = v.h or 0

	self.parent = v.parent

	self.appID = v.appID or "orphan"

	self.circleX = math.random() * self.w
	self.circleY = math.random() * self.h
	self.circleAng = math.random() * (math.pi * 2)
	self.color = {math.random(), math.random(), math.random()}
	self.bgColor = {0.6,0.5,0.5}

	self.counter = math.random() * 2

	self.defaultTitle = "Bouncy Circle"
end

function _app:update(dt)
	self.circleX = self.circleX + math.sin(self.circleAng) * 100 * dt
	self.circleY = self.circleY + math.cos(self.circleAng) * 100 * dt

	if self.circleX < -11 then self.circleX = self.circleX + self.w + 22 end
	if self.circleY < -11 then self.circleY = self.circleY + self.h + 22 end
	if self.circleX > self.w + 11 then self.circleX = self.circleX - self.w + 22 end
	if self.circleY > self.h + 11 then self.circleY = self.circleY - self.h + 22 end

	self.counter = self.counter - dt
	if self.counter <= 0 then
		self.circleAng = math.random() * (math.pi * 2)
		self.counter = math.random() * 2
	end
end

function _app:draw()
	lgr.setColor(1,1,1)
	lgr.circle("fill", math.floor(self.circleX), math.floor(self.circleY), 11)
	lgr.setColor(self.color)
	lgr.circle("fill", math.floor(self.circleX), math.floor(self.circleY), 10)
end

function _app:unload()
	self.loaded = false
end

function _app:resize(w, h)
	if not self.parent.isResizing then
		self.w = w
		self.h = h

		self.circleX = math.random() * self.w
		self.circleY = math.random() * self.h
	end
end

return _app
