local color = {}

function color.HSL(h, s, l, a)
    if s<=0 then return l,l,l,a end
    h, s, l = h/256*6, s/255, l/255
    local c = (1-math.abs(2*l-1))*s
    local x = (1-math.abs(h%2-1))*c
    local m,r,g,b = (l-.5*c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end
    return {(r+m)*255,(g+m)*255,(b+m)*255,a}
end

-- Mulplies r, g, and b with a. This rules out transparent colors which is important in premultiplied mode.
function color.multiplyChannels(r, g, b, a)
   return (r * a)/255, (g * a)/255, (b * a)/255, a
end

-- Function for ImageData:mapPixel. It will give us the image we need for premultiplied.
function color.premultiplyMapPixel(x, y, r, g, b, a)
   return color.multiplyChannels(r, g, b, a)
end

function color.hex2rgb(hex)
    hex = hex:gsub("#","")
    return {tonumber("0x"..hex:sub(1,2)), tonumber("0x"..hex:sub(3,4)), tonumber("0x"..hex:sub(5,6))}
end

return color
