function setupSetPosition(self, v)
	self.x = (v.x or 0)
	self.y = (v.y or 0)
	self.w = 16
	self.h = 16
	gameState:updateCenterPosition(self)

	self.z = 0
	self.vz = v.vz or 0
	self.bounce = 0

	self.mapX = self.x / 16
	self.mapY = self.y / 16
end

function setupAsCollectable(self, v)
	self.nameID = v.nameID

	self.parent = v.parent or gameState

	self.variant = v.variant or 1

	self.frames = v.frames or 8

	self.canActivatePlates = true

	self.colType = "collectable"

	self._lVar = math.random()

	self.fadeTimer = v.fadeTimer or -1

	self.bounceTimer = 3 + math.random() * 10
	self.animationSpeed = v.animationSpeed or 8
	self._origanimationSpeed = self.animationSpeed

	self.giveItem = v.giveItem or "keys"
	self.giveAmount = v.giveAmount or 1

	addWorldCollision(self)

	self.timer = 0--(getGridNoise(1, self.x / 16, self.y / 16))

	if not editorState.loaded then
		if self.giveItem == "keys" then
			self.parent.lighting:addLightSource(self.nameID, self.x, self.y, 24, 1)
			self.parent.lighting:enableSource(self.nameID)
		end
	end
end

function setupAsCanBePickedUp(self, v)
	self.canBePickedUp = true
	self.currentlyPickedUp = false

	self.pickedUpByEntity = function(self, entID, ox, oy, oz)
		self.currentlyPickedUp = entID
		self.parent.gameEntities[self.currentlyPickedUp].pickedUpEntity = self.nameID
		self._pickupOX = ox or 0
		self._pickupOY = oy or 0
		self._pickupOZ = oz or 0
	end

	self.putDownByEntity = function(self, x, y, throw, vx, vy, vz)
		if not self.currentlyPickedUp then return false end
		if not throw then
			self.x = x - self.w / 2
			self.y = y - self.h / 2
			self.z = 0
		else
			self.x = x - self.w / 2
			self.y = y - self.h / 2
			self.z = self._pickupOZ
			self.vx = vx or 0
			self.vy = vy or 0
			self.vz = vz or 0
		end
		self.parent.collisionMap:move(self, self.x, self.y, function() return false end)
		-- print(">>>", self.currentlyPickedUp)
		self.parent.gameEntities[self.currentlyPickedUp].pickedUpEntity = false
		self.currentlyPickedUp = false
	end
end

