local lgr = love.graphics

local _widget = {}

function _widget:create(id, v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(id, v)
	return _i
end
function _widget:setup(id, v)
	self.nameID = id
	self.x = v.x or 0
	self.y = v.y or 0
	self.parent = v.parent
	self.flux = flux.group()
	self.color = {0,0,0,255}
	self.font = self.parent.defaultFont
	self.bgWidth = 0
	self.h = 5

	self.kind = "separator"
	self.invisible = v.invisible or false

	self.onactivate = v.onactivate or nil
end

function _widget:update(dt)
	self.flux:update(dt)
end

function _widget:draw()
	if not self.invisible then
		lgr.push()
		lgr.translate(self.x + 4, self.y + math.floor((self.h - 1) / 2))
		lgr.setColor(self.color)
		lgr.rectangle("fill", 4, 0, self.parent.w - 16, 1)
		lgr.pop()
	end
end

function _widget:activate()
	if self.onactivate then
		self.onactivate(self.value)
	end
end

return _widget
