local lgr = love.graphics
local kbd = love.keyboard
local joy = love.joystick

local input = {}

function input:init(arg)
	self.registers = {
		["a"] = { key = "space", button = "a" },
		["b"] = { key = "b", button = "b" },
		["x"] = { key = "9", button = "x" },
		["y"] = { key = "f5", button = "y" },
		["rightshoulder"] = { key = "f3", button = "rightshoulder" },
		["leftshoulder"] = { key = "f1", button = "leftshoulder" },
	}
	self.buttons = {}
end

function input:registerevent(kind, value, name, func)

end

function input:getdirection(dir)

end

function input:update(dt)

end

function input:draw()
	lgr.push()
	lgr.scale(4)
	lgr.setFont(font.cga)
	local y = 0
	for i, k in pairs(self.registers) do
		local t = i .. ": " .. tostring(self:buttonPressed(i))
		lgr.setColor(0,0,0)
		lgr.print(t, 1, y * 8 + 1)
		lgr.setColor(1,1,1)
		lgr.print(t, 0, y * 8)
		y = y + 1
	end
	lgr.pop()
end

function input:buttonPressed(b)
	return kbd.isDown(self.registers[b].key) or self.buttons[b] or false
end

function input:keypressed(k, r)

end

function input:keyreleased(k, r)

end

function input:textinput(k)

end

local DEADZONE = 0.2
function input:joystickadded(joystick)
	__dprint("joystickadded")
end

function input:joystickaxis(joystick, axis, value)
	if value < -0.2 or value > 0.2 then
		__dprint("joystickaxis", axis, value)
	else
		__dprint("joystickaxis", axis, "return")
	end
end

function input:joystickhat(joystick, hat, direction)
	__dprint("joystickhat", hat, direction)
end

function input:joystickpressed(joystick, button)
	__dprint("joystickpressed", button)
end

function input:joystickreleased(joystick, button)
	__dprint("joystickreleased", button)
end

function input:joystickremoved(joystick)
	__dprint("joystickremoved")
end

function input:gamepadaxis(joystick, axis, value)
	if value < -0.2 or value > 0.2 then
		__dprint("gamepadaxis", axis, value)
	else
		-- __dprint("gamepadaxis", axis, "return")
	end
end

function input:gamepadpressed(joystick, button)
	self.buttons[button] = true
	__dprint("gamepadpressed", button)
end

function input:gamepadreleased(joystick, button)
	self.buttons[button] = false
	__dprint("gamepadreleased", button)
end

return input
