local inventory = {}

function inventory:init(v)
	self.storage = {}
	self:newInventory("global")
end

-- 88b 88 888888 Yb        dP     88 88b 88 Yb    dP 888888 88b 88 888888  dP"Yb  88""Yb Yb  dP     .dP"Y8 888888  dP"Yb  88""Yb    db     dP""b8 888888
-- 88Yb88 88__    Yb  db  dP      88 88Yb88  Yb  dP  88__   88Yb88   88   dP   Yb 88__dP  YbdP      `Ybo."   88   dP   Yb 88__dP   dPYb   dP   `" 88__
-- 88 Y88 88""     YbdPYbdP       88 88 Y88   YbdP   88""   88 Y88   88   Yb   dP 88"Yb    8P       o.`Y8b   88   Yb   dP 88"Yb   dP__Yb  Yb  "88 88""
-- 88  Y8 888888    YP  YP        88 88  Y8    YP    888888 88  Y8   88    YbodP  88  Yb  dP        8bodP'   88    YbodP  88  Yb dP""""Yb  YboodP 888888
function inventory:newInventory(name)
	__dprint("Creating a new inventory for", name)
	if not self.storage[name] then
		self.storage[name] = {}
		return true
	else
		__dprint("Inventory "..name.." already exists")
		return false
	end
end

--    db    8888b.  8888b.      88 888888 888888 8b    d8     888888  dP"Yb
--   dPYb    8I  Yb  8I  Yb     88   88   88__   88b  d88       88   dP   Yb
--  dP__Yb   8I  dY  8I  dY     88   88   88""   88YbdP88       88   Yb   dP
-- dP""""Yb 8888Y"  8888Y"      88   88   888888 88 YY 88       88    YbodP
function inventory:addToInventory(name, item)
	-- print("Adding to inventory:", name, item)
	item = string.lower(item)
	if self.storage[name] then
		local n = #self.storage[name]+1
		self.storage[name][n] = { id = item }
		return true, n
	end
	return false
end

function inventory:getInventoryItems(name)
	return self.storage[name] or {}
end

return inventory
