local lgr = love.graphics
local win = love.window
local lfs = love.filesystem
local kbd = love.keyboard
local tmr = love.timer
local lms = love.mouse


baseState = {}

function baseState:load(arg)
	__dprint("Loading Base State")
	local arg = arg or {}
	self.loaded = true
	self.backgroundUpdate = true
	self.backgroundDraw = true
	self.name = "Menu"

	self:setupBackground()

	self:setupMenu()

	-- self.lines = {
	-- 	{ 0, 40, 100, 60 },
	-- 	{ 45, 0, 60, 100 }
	-- }

	self.flux = flux.group()

	self.circle = {
		w = 64, h = 64, brad = 32, alpha = 0
	}

	self.vignette = lgr.newImage("images/ui/vignette.png")
	self.vignette:setFilter("linear", "linear")
end

function baseState:update(dt)
	lms.setCursor(appCursors.normal)

	self.menu:update(dt)
	self.flux:update(dt)

	-- self.threeDeeGrid:update(dt)

	-- self.lines[1][1] = 50 + math.sin(tmr.getTime() * 2) * 30
	-- self.lines[1][2] = 50 + math.cos(tmr.getTime()) * 30

	-- if kbd.isDown("lshift") then
	-- 	if kbd.isDown("left") then
	-- 		self.lines[1][1] = self.lines[1][1] - dt * 50
	-- 	elseif kbd.isDown("right") then
	-- 		self.lines[1][1] = self.lines[1][1] + dt * 50
	-- 	end
	-- 	if kbd.isDown("down") then
	-- 		self.lines[1][2] = self.lines[1][2] + dt * 50
	-- 	elseif kbd.isDown("up") then
	-- 		self.lines[1][2] = self.lines[1][2] - dt * 50
	-- 	end
	-- end
end

function baseState:draw()
	-- lgr.setColor(100,50,100)
	-- lgr.rectangle("fill", 0, 0, 1000, 1000)


	-- lgr.setColor(200,50,200)
	lgr.setColor(224,222,218)
	lgr.rectangle("fill", 0, 0, self.parentDrawWidth, self.parentDrawHeight)

	-- lgr.setColor(224/2,222/2,218/2,30)
	-- lgr.draw(self.vignette, self.parentDrawWidth / 2, self.parentDrawHeight / 2, 0, self.parentDrawWidth / self.vignette:getWidth(), self.parentDrawHeight / self.vignette:getHeight(), self.vignette:getHeight() / 2, self.vignette:getHeight() / 2)

	-- local rays = {}
	-- for i = 1, 360, 15 do
	-- 	local x = 0 + math.sin(math.rad(i)) * 800
	-- 	local y = 0 + math.cos(math.rad(i)) * 800
	-- 	rays[#rays+1] = {x, y}
	-- end

	-- local sy = 150 - math.floor(75 * self.sunOffsetY)
	-- lgr.push()
	-- lgr.translate(self.sunOffsetX, sy)
	-- lgr.rotate(tmr.getTime() / 2)
	-- lgr.setColor(255,255,255,30 * self.sunOffsetY)
	-- for i = 1, #rays, 2 do
	-- 	lgr.polygon("fill", 0, 0, rays[i][1], rays[i][2], rays[i+1][1], rays[i+1][2])
	-- end
	-- lgr.pop()

	-- lgr.setColor(255,0,255,100)
	-- lgr.circle("fill", self.sunOffsetX, sy, 44)
	-- lgr.setColor(255,0,255)
	-- lgr.circle("fill", self.sunOffsetX, sy, 42)
	-- lgr.setColor(1,1,1)
	-- lgr.circle("fill", self.sunOffsetX, sy, 40)

	-- self.threeDeeGrid:draw(self.sunOffsetY)

	if self.focused then
		self.menu:draw()
	end

	lgr.setColor(0, 0, 0, self.circle.alpha)
	lgr.rectangle("fill", (self.parentDrawWidth / 2) - (self.circle.w / 2), (self.parentDrawHeight / 2) - (self.circle.h / 2), self.circle.w, self.circle.h, self.circle.brad)

	-- lgr.push()
	-- lgr.translate(200, 30)
	-- for i = 1, #self.lines do
	-- 	local l = self.lines[i]
	-- 	lgr.line(l)
	-- end
	-- lgr.setFont(font.cga)
	-- local l = self.lines
	-- local c, x, y = intersectingSegments(l[1][1], l[1][2], l[1][3], l[1][4], l[2][1], l[2][2], l[2][3], l[2][4])
	-- if x and y then
	-- 	lgr.setColor(100,255,100)
	-- 	lgr.circle("fill", math.floor(x)+0.5, math.floor(y)+0.5, 3.5)
	-- 	lgr.setColor(1,1,1)
	-- 	lgr.print(" > " .. tostring(math_round(x,2)) .. ", " .. tostring(math_round(y,2)), 50, 130)
	-- end
	-- lgr.setColor(1,1,1)
	-- lgr.print(tostring(c), 0, 130)
	-- lgr.pop()
end


function baseState:keypressed(k, r)
	self.menu:keypressed(k, r)
end

function baseState:mousepressed(x, y, button)

end


function baseState:unload()
	__dprint("Unloading Base State")
	self.menu:unload()
	self.menu = nil
	self.loaded = false
	self.vignette = nil
	-- self.threeDeeGrid = nil
	-- self.sunOffsetX = nil
	-- self.sunOffsetY = nil
	-- self.lines = nil
	-- self.sunTween = nil
end


function baseState:blur(arg)
	local arg = arg or {}
	self.focused = false
end


function baseState:focus(arg)
	local arg = arg or {}
	self.focused = true
end


function baseState:resize(w, h)
	__dprint("Resize Base State")
end

function baseState:setupBackground()
	-- self.threeDeeGrid = lfs.load("library/threeDeeGrid.lua")()
	-- self.sunOffsetX = self.parentDrawWidth / 2
	-- self.sunOffsetY = 0
	-- if self.sunTween then self.sunTween:stop() end
	-- self.sunTween = flux.to(self, 4, { sunOffsetY = 1 }):ease("quadout")
end

function baseState:setupMenu()
	self.menu = lfs.load("library/gui/gui.lua")()
	self.menu:init { x = 0, y = 0, w = 120, h = RENDERHEIGHT - 12, padLeft = 15, padRight = 15, padTop = 6, padBottom = 6, lineHeight = 12, menuColor = {56,84,99}, headerColor = {56,84,99}, shadowColor = {224,222,218}, bgColor = {0,0,0,0}, rightWidth = 70, defaultFont = font.dialog,
		menuSelectionFont = font.dialog, menuSelectionBGColor = {205,81,117}, menuSelectionColor = {224,222,218}, topHeader = "Choose Thing", onescape = function()
			love.event.quit()
		end
	}
	self.menu:addWidget("top", "button", "game", { label = "Game Test", onactivate = function()
		stateStack.screenFade:setStyle("dither", 5, 1)
		stateStack.screenFade:setSpeed(0.1)
		stateStack.screenFade:setColor(0,0,0)
		stateStack.screenFade:fadeOut(function()
			stateStack:replace(gameState)
			stateStack.screenFade:fadeIn()
		end)
	end })
	self.menu:addWidget("top", "button", "editor", { label = "Map Editor", onactivate = function()
		stateStack:changeDrawDimensions((WINDOW_WIDTH) / editorState.pixelSize, (WINDOW_HEIGHT) / editorState.pixelSize)
		stateStack:replace(editorState, { map = "map"})
	end })
	self.menu:addWidget("top", "button", "mapgen", { label = "Dungeon Generator", onactivate = function()
		stateStack:changeDrawDimensions((WINDOW_WIDTH) / 2, (WINDOW_HEIGHT) / 2)
		stateStack:replace(mapGenState)
	end })
	self.menu:addWidget("top", "button", "cavegen", { label = "Cave Generator", onactivate = function()
		stateStack:changeDrawDimensions((WINDOW_WIDTH) / 1, (WINDOW_HEIGHT) / 1)
		stateStack:replace(caveGenState)
	end })
	self.menu:addWidget("top", "button", "breakout", { label = "Breakout (Proto)", onactivate = function()
		stateStack:changeDrawDimensions(TILESIZE * 16, TILESIZE * 11)
		stateStack:replace(breakout)
	end })
	self.menu:addWidget("top", "button", "mall", { label = "Mall Simulator", onactivate = function()
		stateStack:changeDrawDimensions(TILESIZE * 32, TILESIZE * 18)
		stateStack:replace(mallState)
	end })
	self.menu:addWidget("top", "button", "fps", { label = "FPS Game", onactivate = function()
		-- stateStack:changeDrawDimensions(320, 200)
		self:expandCircle(0.5, "quadout", function()
			stateStack:replace(fpsState)
		end)
	end })
	self.menu:addWidget("top", "button", "windows", { label = "Windowing UI", onactivate = function()
		stateStack:changeDrawDimensions((WINDOW_WIDTH) / 2, (WINDOW_HEIGHT) / 2)
		stateStack:replace(windowingUIState)
	end })
	self.menu:addWidget("top", "button", "noise", { label = "Noise", onactivate = function()
		stateStack:replace(noise)
	end })

	self.menu:addWidget("top", "separator", "3", { invisible = true })
	self.menu:addWidget("top", "button", "vidoption", { label = "Video Options...", onactivate = function()
		self.menu:setPage("vidoptions")
	end })

	self.menu:addPage("vidoptions", "Video Options", { font = font.dialog, headerFont = font.dialogbold })
	self.menu:addWidget("vidoptions", "button", "gameres", { label = "Set Game Resolution...", onactivate = function()
		stateStack:push(vidResOptions)
	end })
	self.menu:addWidget("vidoptions", "checkbox", "scanlines", { label = "CRT Scanlines", value = stateStack.useShader, displayValues = {"Off", "On"},
		onactivate = function(val) stateStack.useShader = val end })
	self.menu:addWidget("vidoptions", "separator", "3", { invisible = true })
	self.menu:addWidget("vidoptions", "button", "2", { label = "Back", onactivate = function() self.menu:back() end })
end

function baseState:expandCircle(time, ease, func)
	func = func or function() end
	time = time or 1
	ease = ease or "linear"
	self.flux:to(self.circle, 0.5, { alpha = 255 }):after(self.circle, time, { w = self.parentDrawWidth, h = self.parentDrawHeight, brad = 0 }):ease(ease):oncomplete(function() func() end)
end
